diff --git a/Makefile b/Makefile
index 3bb6464a1158ae39d3adf75a9e7e56cf8ccc074b..d73682af80d500c9130068ab74d117e665e2a3c6 100644
--- a/Makefile
+++ b/Makefile
@@ -16,6 +16,7 @@ BINPROGS = \
 	crossrepomove
 
 SBINPROGS = \
+	arch-nspawn \
 	mkarchroot \
 	makechrootpkg
 
diff --git a/arch-nspawn.in b/arch-nspawn.in
new file mode 100644
index 0000000000000000000000000000000000000000..0df487544b20af353ca493a553c84bb4a778518f
--- /dev/null
+++ b/arch-nspawn.in
@@ -0,0 +1,99 @@
+#!/bin/bash
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+m4_include(lib/common.sh)
+
+CHROOT_VERSION='v3'
+
+working_dir=''
+
+usage() {
+	echo "Usage: ${0##*/} [options] working-dir [systemd-nspawn arguments]"
+	echo "A wrapper around systemd-nspawn. Provides support for pacman."
+	echo
+	echo ' options:'
+	echo '    -C <file>     Location of a pacman config file'
+	echo '    -M <file>     Location of a makepkg config file'
+	echo '    -c <dir>      Set pacman cache'
+	echo '    -h            This message'
+	exit 1
+}
+
+while getopts 'hC:M:c:' arg; do
+	case "$arg" in
+		C) pac_conf="$OPTARG" ;;
+		M) makepkg_conf="$OPTARG" ;;
+		c) cache_dir="$OPTARG" ;;
+		h|?) usage ;;
+		*) error "invalid argument '$arg'"; usage ;;
+	esac
+done
+shift $(($OPTIND - 1))
+
+(( $EUID != 0 )) && die 'This script must be run as root.'
+(( $# < 1 )) && die 'You must specify a directory.'
+
+working_dir="$(readlink -f $1)"
+shift 1
+
+[[ -z $working_dir ]] && die 'Please specify a working directory.'
+
+if [[ -z $cache_dir ]]; then
+	cache_dirs=($(pacman -v $cache_conf 2>&1 | grep '^Cache Dirs:' | sed 's/Cache Dirs:\s*//g'))
+else
+	cache_dirs=(${cache_dir})
+fi
+
+host_mirror=$(pacman -Sddp extra/devtools 2>/dev/null | sed -r 's#(.*/)extra/os/.*#\1$repo/os/$arch#')
+[[ $host_mirror == *file://* ]] && host_mirror_path=$(echo "$host_mirror" | sed -r 's#file://(/.*)/\$repo/os/\$arch#\1#g')
+
+# {{{ functions
+build_mount_args() {
+	local p
+	declare -g mount_args=()
+
+	if [[ -n $host_mirror_path ]]; then
+		printf -v p '%q' "$host_mirror_path"
+		mount_args+=(--bind-ro="$p")
+	fi
+
+	printf -v p '%q' "${cache_dirs[0]}"
+	mount_args+=(--bind="$p")
+
+	for cache_dir in ${cache_dirs[@]:1}; do
+		printf -v p '%q' "$cache_dir"
+		mount_args+=(--bind-ro="$p")
+	done
+}
+
+copy_hostconf () {
+	cp -a /etc/pacman.d/gnupg "$working_dir/etc/pacman.d"
+	echo "Server = $host_mirror" > $working_dir/etc/pacman.d/mirrorlist
+
+	[[ -n $pac_conf ]] && cp $pac_conf $working_dir/etc/pacman.conf
+	[[ -n $makepkg_conf ]] && cp $makepkg_conf $working_dir/etc/makepkg.conf
+
+	sed -r "s|^#?\\s*CacheDir.+|CacheDir = $(echo -n ${cache_dirs[@]})|g" -i $working_dir/etc/pacman.conf
+}
+# }}}
+
+umask 0022
+
+# Sanity check
+if [[ ! -f "$working_dir/.arch-chroot" ]]; then
+	die "'$working_dir' does not appear to be a Arch chroot."
+elif [[ $(cat "$working_dir/.arch-chroot") != $CHROOT_VERSION ]]; then
+	die "chroot '$working_dir' is not at version $CHROOT_VERSION. Please rebuild."
+fi
+
+build_mount_args
+copy_hostconf
+
+exec systemd-nspawn -D "$working_dir" "${mount_args[@]}" "$@"
diff --git a/archbuild.in b/archbuild.in
index bdb18c051c1d0e7362df10be044461b22573c3c0..7872cd406574cdabc0e2b269795927a9356af173 100644
--- a/archbuild.in
+++ b/archbuild.in
@@ -73,11 +73,11 @@ if ${clean_first} || [[ ! -d "${chroots}/${repo}-${arch}" ]]; then
 		"${chroots}/${repo}-${arch}/root" \
 		"${base_packages[@]}" || abort
 else
-	setarch ${arch} mkarchroot \
-		-u \
+	setarch ${arch} arch-nspawn \
 		-C "@pkgdatadir@/pacman-${repo}.conf" \
 		-M "@pkgdatadir@/makepkg-${arch}.conf" \
-		"${chroots}/${repo}-${arch}/root" || abort
+		"${chroots}/${repo}-${arch}/root" \
+                pacman -Syu --noconfirm || abort
 fi
 
 msg "Building in chroot for [${repo}] (${arch})..."
diff --git a/bash_completion.in b/bash_completion.in
index 9395d3ab8b3f2e06d149add87fb6ea76163274a5..d9948af8bd4f6aad8ea3b8468e5d7b1bea905314 100644
--- a/bash_completion.in
+++ b/bash_completion.in
@@ -53,7 +53,7 @@ _mkarchroot() {
 
   case $cur in
     -*)
-       COMPREPLY=( $( compgen -W '-C -M -c -h -n -r -u' -- "$cur" ) )
+       COMPREPLY=( $( compgen -W '-C -M -c -h' -- "$cur" ) )
        ;;
     *)
       _filedir
@@ -65,5 +65,22 @@ _mkarchroot() {
 } &&
 complete -F _mkarchroot mkarchroot
 
+_arch-nspawn() {
+  local cur
+  COMPREPLY=()
+  _get_comp_words_by_ref cur
+
+  case $cur in
+    -*)
+       COMPREPLY=( $( compgen -W '-C -M -c -h' -- "$cur" ) )
+       ;;
+    *)
+      _filedir
+      return 0
+      ;;
+  esac
 
+  true
+} &&
+complete -F _arch-nspawn arch-nspawn
 # ex:et ts=2 sw=2 ft=sh
diff --git a/makechrootpkg.in b/makechrootpkg.in
index 7796298114f340803f42693633cd2806ba18daf6..bf4034e87e0b3ec45052c3064ecb4ceb67b00471 100644
--- a/makechrootpkg.in
+++ b/makechrootpkg.in
@@ -162,7 +162,7 @@ if [[ -n "${install_pkgs[*]}" ]]; then
 		pkgname="${install_pkg##*/}"
 		cp "$install_pkg" "$copydir/$pkgname"
 
-		mkarchroot -r "pacman -U /$pkgname --noconfirm" "$copydir"
+		arch-nspawn "$copydir" pacman -U /$pkgname --noconfirm
 		(( ret += !! $? ))
 
 		rm "$copydir/$pkgname"
@@ -172,7 +172,7 @@ if [[ -n "${install_pkgs[*]}" ]]; then
 	[[ -f PKGBUILD ]] || exit $ret
 fi
 
-$update_first && mkarchroot -u "$copydir"
+$update_first && arch-nspawn "$copydir" pacman -Syu --noconfirm
 
 mkdir -p "$copydir/build"
 
@@ -288,7 +288,7 @@ exit 0
 EOF
 chmod +x "$copydir/chrootbuild"
 
-if mkarchroot -r "/chrootbuild" "$copydir"; then
+if arch-nspawn "$copydir" /chrootbuild; then
 	for pkgfile in "$copydir"/pkgdest/*.pkg.tar.?z; do
 		if $add_to_db; then
 			mkdir -p "$copydir/repo"
diff --git a/mkarchroot.in b/mkarchroot.in
index 5c1298bddef29519149f07f821e4b8d57add76d4..68db64c90b4029610e071489c043d2c3246702a3 100644
--- a/mkarchroot.in
+++ b/mkarchroot.in
@@ -12,53 +12,33 @@ m4_include(lib/common.sh)
 
 CHROOT_VERSION='v3'
 
-RUN=''
-NOCOPY='n'
-
 working_dir=''
 
-APPNAME=$(basename "${0}")
-
-# usage: usage <exitvalue>
 usage() {
-	echo "Usage: ${APPNAME} [options] working-dir [package-list | app]"
+	echo "Usage: ${0##*/} [options] working-dir [package-list | app]"
 	echo ' options:'
-	echo '    -r <app>      Run "app" within the context of the chroot'
-	echo '    -u            Update the chroot via pacman'
 	echo '    -C <file>     Location of a pacman config file'
 	echo '    -M <file>     Location of a makepkg config file'
-	echo '    -n            Do not copy config files into the chroot'
 	echo '    -c <dir>      Set pacman cache'
 	echo '    -h            This message'
 	exit 1
 }
 
-while getopts 'r:ufnhC:M:c:' arg; do
-	case "${arg}" in
-		r) RUN="$OPTARG" ;;
-		u) RUN='pacman -Syu --noconfirm' ;;
+while getopts 'hC:M:c:' arg; do
+	case "$arg" in
 		C) pac_conf="$OPTARG" ;;
 		M) makepkg_conf="$OPTARG" ;;
-		n) NOCOPY='y' ;;
 		c) cache_dir="$OPTARG" ;;
 		h|?) usage ;;
-		*) error "invalid argument '${arg}'"; usage ;;
+		*) error "invalid argument '$arg'"; usage ;;
 	esac
 done
-
-if (( $EUID != 0 )); then
-	die 'This script must be run as root.'
-fi
-
 shift $(($OPTIND - 1))
 
-if [[ -z $RUN ]] && (( $# < 2 )); then
-	die 'You must specify a directory and one or more packages.'
-elif (( $# < 1 )); then
-	die 'You must specify a directory.'
-fi
+(( $EUID != 0 )) && die 'This script must be run as root.'
+(( $# < 2 )) && die 'You must specify a directory and one or more packages.'
 
-working_dir="$(readlink -f ${1})"
+working_dir="$(readlink -f $1)"
 shift 1
 
 [[ -z $working_dir ]] && die 'Please specify a working directory.'
@@ -69,45 +49,7 @@ else
 	cache_dirs=(${cache_dir})
 fi
 
-host_mirror=$(pacman -Sddp extra/devtools 2>/dev/null | sed -E 's#(.*/)extra/os/.*#\1$repo/os/$arch#')
-if echo "${host_mirror}" | grep -q 'file://'; then
-	host_mirror_path=$(echo "${host_mirror}" | sed -E 's#file://(/.*)/\$repo/os/\$arch#\1#g')
-fi
-
 # {{{ functions
-build_mount_args() {
-	local p
-	declare -g mount_args=()
-
-	if [[ -n $host_mirror_path ]]; then
-		printf -v p '%q' "$host_mirror_path"
-		mount_args+=(--bind-ro="$p")
-	fi
-
-	printf -v p '%q' "${cache_dirs[0]}"
-	mount_args+=(--bind="$p")
-
-	for cache_dir in ${cache_dirs[@]:1}; do
-		printf -v p '%q' "$cache_dir"
-		mount_args+=(--bind-ro="$p")
-	done
-}
-
-copy_hostconf () {
-	cp -a /etc/pacman.d/gnupg "${working_dir}/etc/pacman.d"
-	echo "Server = ${host_mirror}" > ${working_dir}/etc/pacman.d/mirrorlist
-
-	if [[ -n $pac_conf && $NOCOPY = 'n' ]]; then
-		cp ${pac_conf} ${working_dir}/etc/pacman.conf
-	fi
-
-	if [[ -n $makepkg_conf && $NOCOPY = 'n' ]]; then
-		cp ${makepkg_conf} ${working_dir}/etc/makepkg.conf
-	fi
-
-	sed -r "s|^#?\\s*CacheDir.+|CacheDir = $(echo -n ${cache_dirs[@]})|g" -i ${working_dir}/etc/pacman.conf
-}
-
 chroot_lock () {
 	# Only reopen the FD if it wasn't handed to us
 	if [[ $(readlink -f /dev/fd/9) != "${working_dir}.lock" ]]; then
@@ -121,65 +63,33 @@ chroot_lock () {
 		stat_done
 	fi
 }
-
-chroot_run() {
-	local dir=$1
-	shift
-	systemd-nspawn -D "${dir}" "${mount_args[@]}" -- ${@} 2>/dev/null
-}
-
 # }}}
 
 umask 0022
-if [[ -n $RUN ]]; then
-	# run chroot {{{
-	#Sanity check
-	if [[ ! -f "${working_dir}/.arch-chroot" ]]; then
-		die "'${working_dir}' does not appear to be a Arch chroot."
-	elif [[ $(cat "${working_dir}/.arch-chroot") != ${CHROOT_VERSION} ]]; then
-		die "'${working_dir}' is not compatible with ${APPNAME} version ${CHROOT_VERSION}. Please rebuild."
-	fi
 
-	chroot_lock
-	build_mount_args
-	copy_hostconf
+[[ -e $working_dir ]] && die "Working directory '$working_dir' already exists"
 
-	chroot_run "${working_dir}" ${RUN}
+mkdir -p "$working_dir"
 
-	# }}}
-else
-	# {{{ build chroot
-	if [[ -e $working_dir ]]; then
-		die "Working directory '${working_dir}' already exists"
-	fi
+chroot_lock
 
-	mkdir -p "${working_dir}"
-
-	if [[ "$(stat -f -c %T "${working_dir}")" == btrfs ]]; then
-		rmdir "${working_dir}"
-		if ! btrfs subvolume create "${working_dir}"; then
-			die "Couldn't create subvolume for '${working_dir}'"
-		fi
-		chmod 0755 "${working_dir}"
-	fi
-
-	chroot_lock
-
-	pacargs=("${cache_dirs[@]/#/--cachedir=}")
-	if [[ -n $pac_conf ]]; then
-		pacargs+=("--config=${pac_conf}")
-	fi
-
-	if ! pacstrap -GMcd "${working_dir}" "${pacargs[@]}" "$@"; then
-		die 'Failed to install all packages'
+if [[ $(stat -f -c %T "$working_dir") == btrfs ]]; then
+	rmdir "$working_dir"
+	if ! btrfs subvolume create "$working_dir"; then
+		die "Couldn't create subvolume for '$working_dir'"
 	fi
+	chmod 0755 "$working_dir"
+fi
 
-	printf '%s.UTF-8 UTF-8\n' en_US de_DE > "${working_dir}/etc/locale.gen"
-	chroot_run "${working_dir}" locale-gen
-	echo 'LANG=C' > "${working_dir}/etc/locale.conf"
+pacstrap -GMcd ${pac_conf:+-C "$pac_conf"} "$working_dir" \
+  "${cache_dirs[@]/#/--cachedir=}" "$@" || die 'Failed to install all packages'
 
-	copy_hostconf
+printf '%s.UTF-8 UTF-8\n' en_US de_DE > "$working_dir/etc/locale.gen"
+echo 'LANG=C' > "$working_dir/etc/locale.conf"
+echo "$CHROOT_VERSION" > "$working_dir/.arch-chroot"
 
-	echo "${CHROOT_VERSION}" > "${working_dir}/.arch-chroot"
-	# }}}
-fi
+exec arch-nspawn \
+	${pac_conf:+-C "$pac_conf"} \
+	${makepkg_conf:+-M "$makepkg_conf"} \
+	${cache_dir:+-c "$cache_dir"} \
+	"$working_dir" locale-gen
diff --git a/zsh_completion.in b/zsh_completion.in
index c3abdfd925b0208bbc6a5756988acb00db60adea..469df2f223922d8e694842574536bc0da81b90c2 100644
--- a/zsh_completion.in
+++ b/zsh_completion.in
@@ -1,4 +1,4 @@
-#compdef archbuild archco archrelease archrm commitpkg finddeps makechrootpkg mkarchroot rebuildpkgs extrapkg=commitpkg corepkg=commitpkg testingpkg=commitpkg stagingpkg=commitpkg communitypkg=commitpkg community-testingpkg=commitpkg community-stagingpkg=commitpkg multilibpkg=commitpkg multilib-testingpkg=commitpkg extra-i686-build=archbuild extra-x86_64-build=archbuild testing-i686-build=archbuild testing-x86_64-build=archbuild staging-i686-build=archbuild staging-x86_64-build=archbuild multilib-build=archbuild multilib-testing-build=archbuild multilib-staging-build=archbuild kde-unstable-i686-build=archbuild kde-unstable-x86_64-build=archbuild gnome-unstable-i686-build=archbuild gnome-unstable-x86_64-build=archbuild communityco=archco
+#compdef archbuild archco arch-nspawn archrelease archrm commitpkg finddeps makechrootpkg mkarchroot rebuildpkgs extrapkg=commitpkg corepkg=commitpkg testingpkg=commitpkg stagingpkg=commitpkg communitypkg=commitpkg community-testingpkg=commitpkg community-stagingpkg=commitpkg multilibpkg=commitpkg multilib-testingpkg=commitpkg extra-i686-build=archbuild extra-x86_64-build=archbuild testing-i686-build=archbuild testing-x86_64-build=archbuild staging-i686-build=archbuild staging-x86_64-build=archbuild multilib-build=archbuild multilib-testing-build=archbuild multilib-staging-build=archbuild kde-unstable-i686-build=archbuild kde-unstable-x86_64-build=archbuild gnome-unstable-i686-build=archbuild gnome-unstable-x86_64-build=archbuild communityco=archco
 
 m4_include(lib/valid-tags.sh)
 
@@ -11,6 +11,13 @@ _archco_args=(
 	'*:packages:_devtools_completions_all_packages'
 )
 
+_arch_nspawn_args=(
+	'-C[Location of a pacman config file]:pacman_config:_files'
+	'-M[Location of a makepkg config file]:makepkg_config:_files'
+	'-c[Set pacman cache]:pacman_cache:_files -/'
+	'-h[Display usage]'
+)
+
 _archrelease_args=(
 	"*:arch:($_tags[*])"
 )
@@ -40,11 +47,8 @@ _makechrootpkg_args=(
 )
 
 _mkarchroot_args=(
-	'-r[Run a program within the context of the chroot]:app'
-	'-u[Update the chroot via pacman]'
 	'-C[Location of a pacman config file]:pacman_config:_files'
 	'-M[Location of a makepkg config file]:makepkg_config:_files'
-	'-n[Do not copy config files into the chroot]'
 	'-c[Set pacman cache]:pacman_cache:_files -/'
 	'-h[Display usage]'
 )
@@ -61,7 +65,7 @@ _devtools_completions_all_packages() {
 }
 
 _devtools() {
-	local argname="_${service}_args[@]"
+	local argname="_${service//-/_}_args[@]"
 	_arguments -s "${(P)argname}"
 }